/* ------------------------------------------------------------------ */
/*      item            : ActivityLogRequest.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : ActivityLog.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Log request for activity viewing
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated ActivityLogRequest.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_ActivityLogRequest
#endif
#include <TimeSpec.hxx>
#ifdef MASTER_DCO_ActivityLogRequest
#undef MASTER_DCO_ActivityLogRequest
#undef NESTED_DCO
#endif

namespace dueca {
 
/** Request for logging activities
    */
struct ActivityLogRequest
{
  /** typedef for internal reference */
  typedef ActivityLogRequest __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** duration of the activity logging */
  TimeTickType span;

  /** start tick for logging the activities */
  TimeTickType start;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  ActivityLogRequest();

  /** Constructor with arguments */
  ActivityLogRequest(
        const TimeTickType& span,
        const TimeTickType& start);

  /** copy constructor. */
  ActivityLogRequest(const ActivityLogRequest& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an ActivityLogRequest from amorphous storage. */
  ActivityLogRequest(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~ActivityLogRequest();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, ActivityLogRequest*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the ActivityLogRequest into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the ActivityLogRequest into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const ActivityLogRequest& ref) const;

  /** unpacks the ActivityLogRequest from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for ActivityLogRequest
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const ActivityLogRequest& o) const;

  /** Test for inequality. */
  inline bool operator != (const ActivityLogRequest& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  ActivityLogRequest& operator=(const ActivityLogRequest& o);

  /** prints the ActivityLogRequest to a stream. */
  std::ostream & print(std::ostream& s) const;
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::ActivityLogRequest& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::ActivityLogRequest& o,
                         const dueca::ActivityLogRequest& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::ActivityLogRequest& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::ActivityLogRequest& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::ActivityLogRequest& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::ActivityLogRequest>();
template <>
inline const char* dueca::getclassname<const dueca::ActivityLogRequest>()
{ return dueca::getclassname<dueca::ActivityLogRequest>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    ActivityLogRequest is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::ActivityLogRequest> : public dco_isnested { };
};

#endif


