/* ------------------------------------------------------------------ */
/*      item            : LogLevel.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : LogLevel.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once

#include <inttypes.h>

#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
};
#endif

#if !defined(__DCO_STANDALONE)
#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated LogLevel.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>


#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_LogLevel
#endif

#ifdef MASTER_DCO_LogLevel
#undef MASTER_DCO_LogLevel
#undef NESTED_DCO
#endif


namespace dueca {


/** Different log levels
 */
enum LogLevel {
    /** A lot of information, on regular activities */
    Debug,
    /** Some information, on state changes etc. */
    Info,
    /** Not good, but we can handle it */
    Warning,
    /** Error message, trouble */
    Error,
    /** Not a proper level */
    Invalid
};

} 


// Additional custom code
#include "LogLevelExtra.hxx"

namespace dueca {
  const char* const getString(const dueca::LogLevel &o);
  void readFromString(dueca::LogLevel &o, const std::string& s);
  void getFirst(dueca::LogLevel &o);
  bool getNext(dueca::LogLevel &o);
}; // end namespace dueca

#if !defined(__DCO_NOPACK)
void packData(::dueca::AmorphStore& s,
              const dueca::LogLevel &o);
void unPackData(::dueca::AmorphReStore& s,
                dueca::LogLevel &o);
#endif

PRINT_NS_START;
/** Print an object of type LogLevel */
inline std::ostream&
operator << (std::ostream& s, const dueca::LogLevel& o)
{ return s << dueca::getString(o); }
/** Read an enum of type LogLevel */
inline std::istream&
operator >> (std::istream& s, dueca::LogLevel& o)
{ std::string tmp; s >> tmp; dueca::readFromString(o, tmp); return s; }
PRINT_NS_END;

/** This function retrieves the classname of LogLevel */
template <>
const char* dueca::getclassname<dueca::LogLevel>();
template <>
const char* dueca::getenumintrep<dueca::LogLevel>();
template <>
inline const char* dueca::getclassname<const dueca::LogLevel>()
{ return dueca::getclassname<dueca::LogLevel>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
template <>
struct dco_nested<dueca::LogLevel> : public dco_isenum { };
};
#endif
