/* ------------------------------------------------------------------ */
/*      item            : LogLevelCommand.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : LogLevelCommand.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Generated from a hard-coded version
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated LogLevelCommand.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_LogLevelCommand
#endif
#include <LogLevel.hxx>
#include <LogCategory.hxx>
#ifdef MASTER_DCO_LogLevelCommand
#undef MASTER_DCO_LogLevelCommand
#undef NESTED_DCO
#endif

namespace dueca {
 
/** An automatically generated class
    */
struct LogLevelCommand
{
  /** typedef for internal reference */
  typedef LogLevelCommand __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** Node in which the command is to be changed */
  int32_t node;

  /** New level */
  LogLevel level;

  /** Which logging category is to follow that level */
  LogCategory category;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  LogLevelCommand();

  /** Constructor with arguments */
  LogLevelCommand(
        const int32_t& node,
        const LogLevel& level,
        const LogCategory& category);

  /** copy constructor. */
  LogLevelCommand(const LogLevelCommand& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an LogLevelCommand from amorphous storage. */
  LogLevelCommand(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~LogLevelCommand();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, LogLevelCommand*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the LogLevelCommand into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the LogLevelCommand into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const LogLevelCommand& ref) const;

  /** unpacks the LogLevelCommand from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for LogLevelCommand
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const LogLevelCommand& o) const;

  /** Test for inequality. */
  inline bool operator != (const LogLevelCommand& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  LogLevelCommand& operator=(const LogLevelCommand& o);

  /** prints the LogLevelCommand to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "LogLevelCommandExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::LogLevelCommand& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::LogLevelCommand& o,
                         const dueca::LogLevelCommand& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::LogLevelCommand& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::LogLevelCommand& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::LogLevelCommand& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::LogLevelCommand>();
template <>
inline const char* dueca::getclassname<const dueca::LogLevelCommand>()
{ return dueca::getclassname<dueca::LogLevelCommand>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    LogLevelCommand is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::LogLevelCommand> : public dco_isnested { };
};

#endif


