/* ------------------------------------------------------------------ */
/*      item            : LogTime.hxx
        generated by    : Autobuild (abuild)
        date            : Fri 07 Mar 2025
        category        : header file
        description     : DUECA Communication Object (DCO)
                          automatically generated by dueca-codegen
        codegen version : 111
        language        : C++
        item            : LogTime.dco
        made by         : Rene' van Paassen
        date            : 1301002
        description     : Define a logging time
        copyright       : (c) 2016-2022 TUDelft-AE-C&S
                        : (c) 2022 René van Paassen
        license         : EUPL-1.2
*/

#pragma once
#if !defined(__DCO_NOPACK)
namespace dueca {
class AmorphStore;
class AmorphReStore;
struct DataWriterArraySize;
};
#endif

#if !defined(__DCO_STANDALONE)
namespace dueca {
struct CommObjectDataTable;
};

#include <gencodegen.h>
#if GENCODEGEN != 111
#error "Generated LogTime.hxx too old, please clean with 'make mrproper'"
#endif
#include <dueca/CommObjectTraits.hxx>
#endif
#include <iostream>

#ifndef NESTED_DCO
#define NESTED_DCO
#define MASTER_DCO_LogTime
#endif

#ifdef MASTER_DCO_LogTime
#undef MASTER_DCO_LogTime
#undef NESTED_DCO
#endif

namespace dueca {
 
/** defines time of logging action
    */
struct LogTime
{
  /** typedef for internal reference */
  typedef LogTime __ThisDCOType__;

public:
  /** The name of this class. */
  static const char* const classname;


  /** seconds since time datum */
  uint32_t seconds;

  /** microseconds in the second */
  uint32_t usecs;

public:
  /** a "magic" number, hashed out of the class definition,
      that will be used to check consistency of the sent objects
      across the dueca nodes. */
  static const uint32_t magic_check_number;

  /** default constructor. */
  LogTime();

  /** Constructor with arguments */
  LogTime(
        const uint32_t& seconds,
        const uint32_t& usecs);

  /** copy constructor. */
  LogTime(const LogTime& o);

#if !defined(__DCO_NOPACK)
  /** constructor to restore an LogTime from amorphous storage. */
  LogTime(::dueca::AmorphReStore& r);
#endif

  /** destructor. */
  ~LogTime();

#if !defined(__DCO_STANDALONE)
  /** new operator "new", which places objects not on a
      heap, but in one of the memory arenas. This to speed up
      memory management. */
  static void* operator new(size_t size);

  /** accompanying placement operator "new" */
  static void* operator new(size_t size, void* mem);

  /** new operator "delete", to go with the new version
      of operator new. */
  static void operator delete(void* p);

  /** placement "new", needed for stl. */
  inline static void* operator new(size_t size, LogTime*& o)
  { return reinterpret_cast<void*>(o); }
#endif

#if !defined(__DCO_NOPACK)
  /** packs the LogTime into amorphous storage. */
  void packData(::dueca::AmorphStore& s) const;

  /** packs the LogTime into amorphous storage.
      only differences with a previous object are packed. */
  void packDataDiff(::dueca::AmorphStore& s, const LogTime& ref) const;

  /** unpacks the LogTime from an amorphous storage. */
  void unPackData(::dueca::AmorphReStore& s);

  /** unpacks the differences for LogTime
      from an amorphous storage. */
  void unPackDataDiff(::dueca::AmorphReStore& s);
#endif

  /** Test for equality. */
  bool operator == (const LogTime& o) const;

  /** Test for inequality. */
  inline bool operator != (const LogTime& o) const
  { return !(*this == o); }

  /** Assignment operator. */
  LogTime& operator=(const LogTime& o);

  /** prints the LogTime to a stream. */
  std::ostream & print(std::ostream& s) const;

// Additional custom code
#include "LogTimeExtra.hxx"
};

} 

#if !defined(__DCO_NOPACK)
/** pack the object into amorphous storage. */
inline void packData(::dueca::AmorphStore& s,
                     const dueca::LogTime& o)
{ o.packData(s); }

/** pack the differences between this object and another
    into amorphous storage. */
inline void packDataDiff(dueca::AmorphStore& s,
                         const dueca::LogTime& o,
                         const dueca::LogTime& ref)
{ o.packDataDiff(s, ref); }

/** unpack the object from amorphous storage. */
inline void unPackData(::dueca::AmorphReStore& s,
                       dueca::LogTime& o)
{ o.unPackData(s); }

/** unpack the differences to this object from storage. */
inline void unPackDataDiff(dueca::AmorphReStore& s,
                           dueca::LogTime& o)
{ o.unPackDataDiff(s); }
#endif

namespace std {
/** print to a stream. */
inline std::ostream &
operator << (std::ostream& s, const dueca::LogTime& o)
{ return o.print(s); }
};

// specialization of classname
template<>
const char* dueca::getclassname<dueca::LogTime>();
template <>
inline const char* dueca::getclassname<const dueca::LogTime>()
{ return dueca::getclassname<dueca::LogTime>(); }

#if !defined(__DCO_STANDALONE)
namespace dueca {
/** Template specialization, defines a trait that is needed if
    LogTime is ever used inside other dco objects. */
template <>
struct dco_nested<dueca::LogTime> : public dco_isnested { };
};

#endif


